<?php

include 'core.php';

session_start();

cabecera (0);

$command = $_POST["auth_command"];
$user = $_POST["user"];
$passwd = $_POST["passwd"];

switch ( $pkiris['authMethod'] ) {
   default :
      echo("<script type=\"text/javascript\">
      //<![CDATA[
      alert(\"Metodo de autentificacion no soportado\\n Verifique el metodo selecionado en el fichero de configuracion pkIRIS.conf.\");
      location.href='/index.php';
      //]]></script>");
   break;

   // Sin autenticacion
   case "none":
      // Creamos la variable de sesion user para poder mantener la sesion activa en toda la Ra admin.
      $_SESSION['user'] = "Anonimo";
      echo("<script type=\"text/javascript\">
      //<![CDATA[
      location.href='/index.php';
      //]]></script>");
   break;

   // Autenticacion mediante certificado
   case "ldap":
      //Buscamos al usuario en ldap por el pkirisID
      $filter = "(&(objectclass=pkirisEndEntity)(pkirisID=$user))";
      $justthese = array("dn");
      $result = ldap_get_info($ldapVar['base'],$filter,$justthese);
      if ($result == false) {
         session_destroy();
         echo("<script type=\"text/javascript\">
         //<![CDATA[
         alert(\"El usuario no existe en el directorio. Para poder ingresar al sistema necesita tener un usuario valido con un certificado emitido por la CA.\");
         location.href='/index.php';
         //]]>
         </script>");
      }
      else {
         $dn = $info[0]["dn"];
         $subjectDn = $result[0]["dn"];
         echo $subjectDn;

         // Hacemos un bind al ldap para verificar la password del usuario.
         $ds = ldap_connect($ldapVar['server'], $ldapVar['port']) or die("Could not connect to " . $ldapVar['server']);
         if ($ds) {
            $ldapbind = ldap_bind($ds, $subjectDn, $passwd);
            if ($ldapbind) {
               // Creamos la variable de sesion user para poder mantener la sesion activa en toda la Ra admin.
               $_SESSION['user'] = $user;
               echo("<script type=\"text/javascript\">
               //<![CDATA[
               location.href='/index.php';
               //]]>
               </script>");
            }
            else {
               session_destroy();
               echo("<script type=\"text/javascript\">
               //<![CDATA[
               alert(\"Password incorrecta, por favor intentelo nuevamente.\");
               location.href='/index.php';
               //]]>
               </script>");														     
            } 
         }
      }
   break;
   // Autenticacion mediante usuario y contrasenya, almacenados en un fichero
   // de texto plano. Los permisos del usuario se guardan en un fichero llamado perm.
   // Teniendo en cuenta que el Certificado concuerde con el usuario que ha entrado.
   case "plainCc":
      $foundUser = 0;
      $passwdFile = fopen ($dirVar['conf'] . "passwd", "r"); // Poner como variable global

      $buf = fgets ($passwdFile); 

      while (!$foundUser && !feof($passwdFile) ) {
         list ($userFile, $passFile) = split (":", $buf);
         if ($userFile == $user) {
            $foundUser = 1;
	    $passFile = trim($passFile);
	    if ($passFile == $passwd) {
	       // Creamos la variable de sesion user para poder mantener la sesion activa en toda la Ra admin.
	       $_SESSION['user'] = $user;
	       $permFile = fopen ($dirVar['conf'] . "perm", "r"); // Poner como variable global
	       $buf2 = fgets ($permFile);
	       $i = 0;
	       while (!feof($permFile)) {
	          list ($userFile, $urnFile) = split (";", $buf2);
		  if ($user == $userFile) {
		     $urns[$i] = $urnFile;	  
		  }
		  $buf2 = fgets($permFile);
		  $i++;
	       }
	       fclose ($permFile);
	       echo("<script type=\"text/javascript\">
	       //<![CDATA[
	       location.href='/index.php';
	       //]]>
	       </script>");
	    }
	    else {
	       session_destroy();
	       echo("<script type=\"text/javascript\">
	       //<![CDATA[
	       alert(\"Usuario y/o contrase&ntilde;a incorrecto/a, por favor intentelo nuevamente.\");
	       location.href='/index.php';
	       //]]>
	       </script>");
	    }
	}
	$buf = fgets ($passwdFile);
      }
      fclose ($passwdFile);
      if ( !$foundUser ){
         session_destroy();
         echo("<script type=\"text/javascript\">
         //<![CDATA[
         alert(\"Usuario o contraseña incorrecto/a, por favor intentelo nuevamente.\");
         location.href='/index.php';
         //]]>
         </script>");
      }

   break;
   // Autenticacion mediante usuario y contrasenya, almacenados en un fichero 
   // de texto plano. Los permisos del usuario se guardan en un fichero llamado perm.
   case "plainSc":
            $foundUser = 0;
            $passwdFile = fopen ($dirVar['conf'] . "passwd", "r"); // Poner como variable global
            $buf = fgets ($passwdFile); 
	    
            while (!$foundUser && !feof($passwdFile) ) {
               list ($userFile, $passFile) = split (":", $buf);
      	       if ($userFile == $user) {
   	          $foundUser = 1;
		  $passFile = trim($passFile);
		  if ($passFile == $passwd) {
                     // Creamos la variable de sesion user para poder mantener la sesion activa en toda la Ra admin.
                     $_SESSION['user'] = $user;
	                 $permFile = fopen ($dirVar['conf'] . "perm", "r"); // Poner como variable global
			 $buf2 = fgets ($permFile);
			 $i = 0;
			 while (!feof($permFile)) {
			    list ($userFile, $urnFile) = split (";", $buf2);
			    if ($user == $userFile) {
			       $urns[$i] = $urnFile;
			    }
			    $buf2 = fgets($permFile);
			    $i++;
			 }
		      fclose ($permFile);
		
	              echo("<script type=\"text/javascript\">
                      //<![CDATA[
                      location.href='/index.php';
                      //]]>
                      </script>");
                  }
                  else {
                     session_destroy();
                     echo("<script type=\"text/javascript\">
                     //<![CDATA[
                     alert(\"Usuario o contraseña incorrecto/a, por favor intentelo nuevamente.\");
                     location.href='/index.php';
                     //]]>
                     </script>");
                  }	
	       }
  	       $buf = fgets ($passwdFile);
            }  
            fclose ($passwdFile);
            if ( !$foundUser ){
               session_destroy();
               echo("<script type=\"text/javascript\">
               //<![CDATA[
               alert(\"Usuario o contraseña incorrecto/a, por favor intentelo nuevamente.\");
               location.href='/index.php';
               //]]>
               </script>");
            }	
   break;

   // Autenticacion mediante papi
   case "papi":

   break;
		 
}

pie ();

?>
